/*----------------------------------------------------------------------------*/
/*
  This file is generated by Code_Saturne, a general-purpose CFD tool.
*/
/*----------------------------------------------------------------------------*/

#include "cs_defs.h"

/*----------------------------------------------------------------------------
 * Standard C library headers
 *----------------------------------------------------------------------------*/

#include <assert.h>
#include <math.h>

#if defined(HAVE_MPI)
#include <mpi.h>
#endif

/*----------------------------------------------------------------------------
 *  Local headers
 *----------------------------------------------------------------------------*/

#include "cs_headers.h"

/*----------------------------------------------------------------------------*/

BEGIN_C_DECLS

/*----------------------------------------------------------------------------*/

cs_real_t *
cs_meg_boundary_function(const cs_zone_t *zone,
                         const char      *field_name,
                         const char      *condition)
{
  cs_real_t *new_vals = NULL;

  /* User defined formula for "velocity" over BC=in_air
    --------------------------------------------------- */

  if (strcmp(field_name, "velocity") == 0 &&
      strcmp(condition, "norm_formula") == 0 &&
      strcmp(zone->name, "in_air") == 0) {

    const cs_lnum_t vals_size = zone->n_elts * 1;
    BFT_MALLOC(new_vals, vals_size, cs_real_t);

    const cs_real_t in_air = cs_notebook_parameter_value_by_name("in_air");

    for (cs_lnum_t e_id = 0; e_id < zone->n_elts; e_id++) {
      cs_lnum_t f_id = zone->elt_ids[e_id];
      new_vals[0 * zone->n_elts + e_id] = in_air;
    }
  }

  /* User defined formula for "velocity" over BC=in_h2
    -------------------------------------------------- */

  if (strcmp(field_name, "velocity") == 0 &&
      strcmp(condition, "norm_formula") == 0 &&
      strcmp(zone->name, "in_h2") == 0) {

    const cs_lnum_t vals_size = zone->n_elts * 1;
    BFT_MALLOC(new_vals, vals_size, cs_real_t);

    const cs_real_t in_h2 = cs_notebook_parameter_value_by_name("in_h2");

    for (cs_lnum_t e_id = 0; e_id < zone->n_elts; e_id++) {
      cs_lnum_t f_id = zone->elt_ids[e_id];
      new_vals[0 * zone->n_elts + e_id] = in_h2;
    }
  }
  return new_vals;
}

/*----------------------------------------------------------------------------*/

END_C_DECLS

